'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: base_01.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: msc $ $Date: 2003/04/29 12:46:01 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**********************************************************************************
'*
'* owner : marc.schwanz@sun.com
'*
'* short description : Misc. and Tab Pages routines for Base Update Test
'*
'************************************************************************
'*
' #1 tDataSourceAdministration
' #1 tNewDataSourceCheck
' #1 tTypes
' #1 tTabGeneral   
' #1 tTabTables
' #1 tTabQueries
' #1 tTabBookmarks
'*
'\***********************************************************************************
Dim gCountOfTypes as integer

sub base_01

   printlog "------------------ base_01.inc ---------------------"
   printlog "-------------------- Misc. -------------------------"

     call tDataSourceAdministration
     call tNewDataSourceCheck
     call tTypes
     call tTabGeneral   
     call tTabTables
     call tTabQueries
     
     ' comment because of bug 109212
     ' call tTabBookmarks

end sub

'-------------------------------------------------------------------------

testcase tDataSourceAdministration
 Dim SourcesName as string
 Dim SourcesNameVerify as string
 Dim SourcesNameTwo as string
 Dim NewSourceText as string

 Dim a as integer
 Dim i as integer

 Dim FoundNewDatabaseEntry as boolean

 '/// Default settings ///'
 FoundNewDatabaseEntry = FALSE

 '/// Description ///'
 printlog "Misc. window test"
  call hNewDocument
  ToolsDataSources
  Kontext "DataSourceAdministration"
   call Dialogtest (DataSourceAdministration)
   '/// Default should be one source (bibliography)! ///'
   i = DatabaseSourceList.GetItemCount
   'if i > 2 then
   '  warnlog "There should be 1 (or 2 MSC) database(s) source in the list but there are " & i & " in the list!"
   'end if
   if i > 0 then
     for a = 1 to i
       SourcesName = DatabaseSourceList.GetItemText(a)
       printlog "Existing sources (" & a &"/" & i & "): " & SourcesName
     next a
    else
     warnlog "There are no data sources available! Bug!"
   end if
   '/// New data source button. ///'
   NewDataSource.Click
  Kontext "TabGeneral"
   NewSourceText = SourceName.GetText
   sleep(1)
  Kontext "DataSourceAdministration"
   DatabaseSourceList.Typekeys "<TAB>" , 9
   sleep(1)
   DatabaseSourceList.TypeKeys "<HOME>"
   for a = 1 to i+1
    SourcesNameVerify = DatabaseSourceList.GetItemText(a)
    if SourcesNameVerify = NewSourceText then
      FoundNewDatabaseEntry = TRUE
      exit for
     else
      DatabaseSourceList.TypeKeys "<DOWN>"
    end if
   next a
   if FoundNewDatabaseEntry = FALSE then
     warnlog "The new data source has not been found in list! Bug!"
   end if
  Kontext "DataSourceAdministration"
   DataSourceAdministration.Cancel
   call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tNewDataSourceCheck
 Dim NewSourceText as string
 Dim SourcesNameVerify as string
 Dim StateOfDel as string

 Dim CountPlusNew as integer
 Dim i as integer
 Dim a as integer
 Dim ListCountA as integer
 Dim ListCountB as integer

 Dim Isliste(10) as string

 '/// Description ///'
 printlog "Will a new database source entry be stored?"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  DatabaseSourceList.Typekeys "<TAB>" , 9
  i = DatabaseSourceList.GetItemCount
  NewDataSource.Click
  sleep(1)
 Kontext "TabGeneral"
  NewSourceText = SourceName.GetText
  sleep(1)
 Kontext "DataSourceAdministration"
  for i = 1 to i+1
   IsListe(0) = 0
   IsListe(i) = DatabaseSourceList.GetItemText(i)
   printlog "Database source " & i & ": " & IsListe(i)
  next i
  ListCountA = DatabaseSourceList.GetItemCount
  printlog "Count of entries after adding a new database source: " & ListCountA
  DataSourceAdministration.OK
  sleep(1)
  ToolsDataSources
 Kontext "DataSourceAdministration"
  DatabaseSourceList.Typekeys "<TAB>" , 9
  DatabaseSourceList.TypeKeys "<HOME>"
  ListCountB = DatabaseSourceList.GetItemCount
  if ListCountB <> ListCountA then
   warnlog "New database source entry has not been stored! Bug!"
  end if
  for a = 1 to ListCountB
   Kontext "DataSourceAdministration"
    SourcesNameVerify = DatabaseSourceList.GetItemText(a)
    if SourcesNameVerify = NewSourceText then
        DatabaseSourceList.Select(a)
        sleep(1)
        DatabaseSourceList.TypeKeys "<DELETE>"
       Kontext "TabGeneral"
        StateOfDel = StatusMessage.Caption
        if StateOfDel <> "" then
          printlog "Entry >" & SourcesNameVerify & "< deleted."
         else
          warnlog "No status message?! Has the entry been deleted?!"
        end if
        exit for
     else
     DatabaseSourceList.Select(a+1)
    end if
  next a
 Kontext "DataSourceAdministration"
  DataSourceAdministration.OK
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTypes
    Dim CountOfTypes as integer
    Dim i as integer
    Dim Isliste(10) as string

    '/// Description ///'
    printlog "Checking database types..."
    call hNewDocument
    ToolsDataSources
    Kontext "TabGeneral"
        CountOfTypes = DatabaseType.GetItemCount        
        if gPlatGroup = "w95" then
            gCountOfTypes = 9
        elseif gPlatform = "x86" then
            gCountOfTypes = 7
        else
            gCountOfTypes = 8
        end if        
        if CountOfTypes <> gCountOfTypes then
            warnlog "There are instead of " & gCountOfTypes & " database types " & CountOfTypes & " types available?"
        end if
    ' put all items to a array      
    IsListe(0) = 0
    for i = 1 to CountOfTypes
        IsListe(i) = DatabaseType.GetItemText(i)
    next i
    ' check the items in this array
    for i = 1 to CountOfTypes
        if gPlatform = "x86" then
            select case i
                case 1    : 
                    if IsListe(i) <> "MySQL" then
                        warnlog "MySQL should be the first entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "MySQL is the first entry in the listbox."
                    end if
                case 2    :
                    if IsListe(i) <> "JDBC" then
                        warnlog "JDBC should be the second entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "JDBC is the second entry in the listbox."
                    end if
                case 3    :
                    if IsListe(i) <> "ODBC" then
                        warnlog "ODBC should be the third entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "ODBC is the third entry in the listbox."
                    end if
                case 4    :
                    if IsListe(i) <> "dBase" then
                        warnlog "dBase should be the fourth entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "dBase is the fourth entry in the listbox."
                    end if
                case 5    : 
                    if iSprache = 1 then
                        if IsListe(i) <> "Text" then
                            warnlog "Text should be the sixth entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "TEXT is the sixth entry in the listbox."
                        end if
                    end if
                case 6    :
                    if iSprache = 1 then
                        if IsListe(i) <> "Spreadsheet" then
                            warnlog "Spreadsheet should be the fifth entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "SPREADSHEET is the seventh entry in the listbox."
                        end if
                    end if
                case 7    :
                    if iSprache = 1 then
                        if IsListe(i) <> "Address book" then
                            warnlog "Address book should be the eights entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "Address book is the eights entry in the listbox."
                        end if
                    end if
                case else :
                    warnlog "Don't know what '" & IsListe(i) & "' is?!"
            end select
        elseif gPlatGroup="w95" then 
            select case i
                case 1    : 
                    if IsListe(i) <> "MySQL" then
                        warnlog "MySQL should be the first entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "MySQL is the first entry in the listbox."
                    end if
                case 2    :
                    if IsListe(i) <> "Adabas" then
                        warnlog "Adabas should be the second entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "Adabas is the second entry in the listbox."
                    end if                
                case 3    :
                    if IsListe(i) <> "JDBC" then
                        warnlog "JDBC should be the second entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "JDBC is the second entry in the listbox."
                    end if
                case 4    :
                    if IsListe(i) <> "ODBC" then
                        warnlog "ODBC should be the third entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "ODBC is the third entry in the listbox."
                    end if
                case 5    :
                    if IsListe(i) <> "dBase" then
                        warnlog "dBase should be the fourth entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "dBase is the fourth entry in the listbox."
                    end if           
                case 6    :
                    if IsListe(i) <> "ADO" then
                        warnlog "ADO should be the fourth entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "ADO is the fourth entry in the listbox."
                    end if
                case 7    : 
                    if iSprache = 1 then
                        if IsListe(i) <> "Text" then
                            warnlog "Text should be the sixth entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "TEXT is the sixth entry in the listbox."
                        end if
                    end if
                case 8    :
                    if iSprache = 1 then
                        if IsListe(i) <> "Spreadsheet" then
                            warnlog "Spreadsheet should be the fifth entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "SPREADSHEET is the seventh entry in the listbox."
                        end if
                    end if
                case 9    :
                    if iSprache = 1 then
                        if IsListe(i) <> "Address book" then
                            warnlog "Address book should be the eights entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "Address book is the eights entry in the listbox."
                        end if
                    end if
                case else :
                    warnlog "Don't know what '" & IsListe(i) & "' is?!"
            end select
        else
            select case i
                case 1    : 
                    if IsListe(i) <> "MySQL" then
                        warnlog "MySQL should be the first entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "MySQL is the first entry in the listbox."
                    end if
                case 2    :
                    if IsListe(i) <> "Adabas" then
                        warnlog "Adabas should be the second entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "Adabas is the second entry in the listbox."
                    end if                
                case 3    :
                    if IsListe(i) <> "JDBC" then
                        warnlog "JDBC should be the second entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "JDBC is the second entry in the listbox."
                    end if
                case 4    :
                    if IsListe(i) <> "ODBC" then
                        warnlog "ODBC should be the third entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "ODBC is the third entry in the listbox."
                    end if
                case 5    :
                    if IsListe(i) <> "dBase" then
                        warnlog "dBase should be the fourth entry in the types list box but it is " & IsListe(i) & "."
                    else
                        printlog "dBase is the fourth entry in the listbox."
                    end if
                case 6    : 
                    if iSprache = 1 then
                        if IsListe(i) <> "Text" then
                            warnlog "Text should be the sixth entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "TEXT is the sixth entry in the listbox."
                        end if
                    end if
                case 7    :
                    if iSprache = 1 then
                        if IsListe(i) <> "Spreadsheet" then
                            warnlog "Spreadsheet should be the fifth entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "SPREADSHEET is the seventh entry in the listbox."
                        end if
                    end if
                case 8    :
                    if iSprache = 1 then
                        if IsListe(i) <> "Address book" then
                            warnlog "Address book should be the eights entry in the types list box but it is " & IsListe(i) & "."
                        else
                            printlog "Address book is the eights entry in the listbox."
                        end if
                    end if
                case else :
                    warnlog "Don't know what '" & IsListe(i) & "' is?!"
            end select
        end if
    next i
    Kontext "DataSourceAdministration"
        DataSourceAdministration.Cancel
    call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabGeneral
 Dim ListCountA as integer
 Dim xURLEntry as string
 Dim xURLEntryOne as string
 Dim a as integer
 '/// Description ///'
 if gPlatgroup = "w95" OR gPlatform = "sol" OR gPlatform = "lin" then
   a = 1
  else
   a = 0
 end if
 printlog "General tab page"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  TabControl.SetPage TabGeneral
 Kontext "TabGeneral"
  if gPlatgroup = "w95" OR gPlatform = "sol" OR gPlatform = "lin" then
    DatabaseType.Select(2)
    printlog "Checking Sources/SelectPath Button for Adabas."
    SelectPath.Click
      try
         Kontext "DataSourceSelection"
          ListCountA = SourceList.GetItemCount
          printlog "Available Adabas Sources: " & ListCountA
          call Dialogtest (DataSourceSelection)
          sleep(3)
          if DataSourceSelection.Exists(2) then
           try
             DataSourceSelection.Close
            catch
             DataSourceSelection.Cancel
           endcatch
          end if
        catch
        Kontext "Messagebox"
        if Messagebox.Exists then
          if MessageBox.GetRT = 304 then
           warnlog Messagebox.GetText
           Messagebox.Ok
          end if
        end if
       endcatch
  end if
  printlog "Checking Sources/SelectPath Button for ODBC."
 Kontext "TabGeneral"
  DatabaseType.Select(a+3)
  SelectPath.Click
  try
    Kontext "DataSourceSelection"
     if NOT Organize.IsVisible then
      warnlog "'Organize'-button not visible! Bug!"
     end if
     call Dialogtest (DataSourceSelection)
     sleep(3)
     if DataSourceSelection.Exists(2) then
      try
        DataSourceSelection.Close
       catch
        DataSourceSelection.Cancel
      endcatch
     end if
   catch
   Kontext "Messagebox"
   if Messagebox.Exists then
    if MessageBox.GetRT = 304 then
     warnlog Messagebox.GetText
     Messagebox.Ok
    end if
   end if
  endcatch
  printlog "Checking Sources/SelectPath Button for dBase."
 Kontext "TabGeneral"
  DatabaseType.Select(a+4)
  SelectPath.Click
  xURLEntryOne = DataSourceURL.GetText
  sleep(2)
 Kontext "OeffnenDlg"
  call Dialogtest(OeffnenDlg)
  OeffnenDlg.Cancel
 Kontext "TabGeneral"
  xURLEntry = DataSourceURL.GetText
  if xURLEntry <> xURLEntryOne then
    warnlog "Using CANCEL button enters the selected path in Data Source URL!!! See OLD/CLOSED BugId: 86932"
  end if
  printlog "Checking Sources/SelectPath Button for TEXT base."
 Kontext "TabGeneral"
  if gPlatform = "x86" OR gPlatform = "os2" OR gPlatform = "os4" OR gPlatform = "mac" then
    DatabaseType.Select(a+5)
   else
    if gPlatgroup = "w95" then
      DatabaseType.Select(a+6)
     else
      DatabaseType.Select(a+5)
    end if
  end if
  xURLEntryOne = DataSourceURL.GetText
  sleep(2)
  SelectPath.Click
  sleep(3)
 Kontext "OeffnenDlg"
  call Dialogtest(OeffnenDlg)
  OeffnenDlg.Cancel
 Kontext "TabGeneral"
  xURLEntry = DataSourceURL.GetText
  if xURLEntry <> xURLEntryOne then
    warnlog "Using CANCEL button enters the selected path in Data Source URL!!! See OLD/CLOSED BugId: 86932"
  end if
  printlog "Checking Sources/SelectPath Button for Spreadsheet."
 Kontext "TabGeneral"
  DatabaseType.Select(gCountOfTypes-1)
  xURLEntryOne = DataSourceURL.GetText
  sleep(2)
  SelectPath.Click
  sleep(3)
 Kontext "GeneralFileDialog"
  call Dialogtest(GeneralFileDialog)
  GeneralFileDialog.Cancel
 Kontext "TabGeneral"
  xURLEntry = DataSourceURL.GetText
  if xURLEntry <> xURLEntryOne then
    warnlog "Using CANCEL button enters the selected path in Data Source URL!!! See OLD/CLOSED BugId: 86932"
  end if
  printlog "Checking Sources/SelectPath Button for Addressbook."
 Kontext "TabGeneral"
  DatabaseType.Select(gCountOfTypes)
  xURLEntryOne = DataSourceURL.GetText
  sleep(2)
  SelectPath.Click
  sleep(3)
 Kontext "DataSourceSelection"
  call Dialogtest(DataSourceSelection)
  DataSourceSelection.Cancel
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabTables
 Dim EntriesOfSelector as integer
 '/// Description ///'
 printlog "tab page tables"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  TabControl.SetPage TabTables
 Kontext "TabTables"
  EntriesOfSelector = Selector.GetItemCount
  if EntriesOfSelector < 1 then
   warnlog "There should be >0 main entries in tables selector in bibliography database (All tables; biblio)!"
  end if
  if NOT DisplayVersionColumns.IsChecked then warnlog "'Display versions columns' should be checked but it isn't!"
  call Dialogtest(TabTables)
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabQueries
 '/// Description ///'
 printlog "tab page queries"
  call hNewDocument
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  TabControl.SetPage TabQueries
 Kontext "TabQueries"
  call Dialogtest(TabQueries)
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase

'-------------------------------------------------------------------------

testcase tTabBookmarks
 '/// Description ///'
 Dim ItemsOfListA as integer
 Dim ItemsOfListB as integer
 printlog "tab page bookmarks"
  call hNewDocument
  Kontext "DocumentWriter"
  DocumentWriter.Typekeys "Hello world"
  ToolsDataSources
 Kontext "DataSourceAdministration"
  call Dialogtest (DataSourceAdministration)
  TabControl.SetPage TabBaseBookmarks
 Kontext "TabBaseBookmarks"
  '/// Checking count of existing links ///
  ItemsOfListB = Bookmarklist.GetItemCount
  printlog "Existing Links: " & ItemsOfListB
  Bookmarklist.TypeKeys "<DOWN>"
  sleep(1)
  Bookmarklist.TypeKeys "<UP>"
  sleep(1)
  call Dialogtest(TabBaseBookmarks)
 Kontext "TB_BaseLinks"
  NewLink.Click
  sleep(2)
 Kontext "NewLinkDLG"
  call Dialogtest (NewLinkDLG)
  Browse.Click
  sleep(2)
 Kontext "OeffnenDlg"
  call Dialogtest (OeffnenDlg)
  OeffnenDlg.Cancel
  sleep(1)
 Kontext "NewLinkDLG"
  NewLinkDLG.Cancel
  '/// Adding a link and testing functionality ///
 Kontext "TB_BaseLinks"
  NewLink.Click
  sleep(2)
 Kontext "NewLinkDLG"
  '/// Creating with name Testlink ///
  LinkName.SetText "Testlink"
  LinkURL.SetText (gTesttoolPath & ConvertPath("base\update\input\formular1_1.sxw"))
 try
   NewLinkDLG.OK
  catch
   printlog "Link already exists. Will delete it!"
    NewLinkDLG.Cancel
   Kontext "TB_BaseLinks"
    if DeleteLink.IsEnabled then
      DeleteLink.Click
     else
      warnlog "Can not delete existing link!"
    end if
   Kontext "Messagebox"
    if Messagebox.Exists then
     if MessageBox.GetRT = 304 then
      Messagebox.Yes
     end if
    end if
   Kontext "TB_BaseLinks"
    NewLink.Click
    sleep(2)
   Kontext "NewLinkDLG"
    LinkName.SetText "Testlink"
    LinkURL.SetText (gTesttoolPath & ConvertPath("base\update\input\formular1_1.sxw"))
    NewLinkDLG.OK
 endcatch
  sleep(2)
 Kontext "TabBaseBookmarks"
  '/// Verifying that the link has been created ///
  ItemsOfListB = Bookmarklist.GetItemCount
  if NOT ItemsOfListB = ItemsOfListA+1 then warnlog "New Link has not been created!"
  Bookmarklist.TypeKeys "<DOWN>"
  sleep(1)
  Bookmarklist.TypeKeys "<UP>"
  sleep(1)
 Kontext "TB_BaseLinks" 
  '/// Edit the link ///
  EditLink.Click
 Kontext "Messagebox"
  if Messagebox.Exists(3) then
    if MessageBox.GetRT = 304 then
     warnlog Messagebox.GetText
     Messagebox.OK
    end if
  end if
 Kontext "NewLinkDLG"
  NewLinkDLG.Cancel
 Kontext "TB_BaseLinks"
  '/// Open the document behind the link ///
  OpenDocument.Click
   Kontext "Messagebox"
    if Messagebox.GetRT = 304 then
       printlog Messagebox.GetText
       Messagebox.OK
     else
       sleep(10)
      Kontext "DocumentWriter"
       FileClose
       sleep(4)
    end if
 Kontext "TB_BaseLinks"
  '/// Edit the document behind the link ///
  EditDocument.Click
  sleep(10)
   Kontext "Messagebox"
    if Messagebox.GetRT = 304 then
       printlog Messagebox.GetText
       Messagebox.OK
     else
      Kontext "DocumentWriter"
       FileClose
       sleep(4)
    end if
 Kontext "TB_BaseLinks"
  DeleteLink.Click
 Kontext "Messagebox"
    if MessageBox.GetRT = 304 then
     Messagebox.Yes
    end if
 Kontext "TabBaseBookmarks"
  ItemsOfListB = Bookmarklist.GetItemCount
  if NOT ItemsOfListB = ItemsOfListA then warnlog "New Link has not been deleted!"
 Kontext "DataSourceAdministration"
  DataSourceAdministration.Cancel
 call hCloseDocument
endcase
