'*************************************************************************
'*
'*  $RCSfile: topten.inc,v $
'*
'*  $Revision: 1.1.1.1 $
'*
'*  last change: $Author: ms $ $Date: 2003/03/18 17:52:53 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : Smoke test (load/save/clipboard)
'*
'************************************************************************
'*
' #1 Top_ten_test       '  check load/save/clipboard in all applications'*
'*
'\***********************************************************************

sub topten

   gApplication = "WRITER"
   printlog "** " + gApplication
   call Top_ten_test

   gApplication = "CALC"
   printlog "** " + gApplication
   call Top_ten_test

   gApplication = "IMPRESS"
   printlog "** " + gApplication
   call Top_ten_test

   gApplication = "DRAW"
   printlog "** " + gApplication
   call Top_ten_test

   gApplication = "MATH"
   printlog "** " + gApplication
   call Top_ten_test

   gApplication = "HTMLDOKUMENT"
   printlog "** " + gApplication
   call Top_ten_test

   gApplication = "MASTERDOC"
   printlog "** " + gApplication
   call Top_ten_test

end sub

' --------------------------------------------------------------------------------

testcase Top_ten_test
'///Top-Ten-Test
'///<ul><li>open all document types</li>
'///+<li>insert a text or a rectangle (Draw/Impress)</li>
'///+<li>cut - paste / copy - paste</li>
'///+<li>save as default-format (6.0format (XML))</li>
'///+<li>save as 5.2-format</li>
'///+<li>close the doc</li>
'///+<li>load the 6.0-doc, change it, save this changes and close the doc</li>
'///+<li>load the 5.2-doc, change it, save this changes and close the doc</li></ul>

   Dim sApp  as String, DokName1 as String, DokName2 as String
   Dim sMastList ( 20 ) as String
   Dim i as Integer

   gApplication = UCase (gApplication)
   select case gApplication
      case "WRITER" : DokName1 = "ls_test.sxw"
                      sApp = "StarWriter 5.0 (.sdw)"
                      DokName2 = "ls_test.sdw"

      case "CALC"   : DokName1 = "ls_test.sxc"
                      sApp = "StarCalc 5.0 (.sdc)"
                      DokName2 = "ls_test.sdc"

      case "DRAW"   : DokName1 = "ls_test.sxd"
                      sApp = "StarDraw 5.0 (.sda)"
                      DokName2 = "ls_test.sda"

      case "IMPRESS": DokName1 = "ls_test.sxi"
                      sApp = "StarImpress 5.0 (.sdd)"
                      DokName2 = "ls_test.sdd"

      case "MATH"   : DokName1 = "ls_test.sxm"
                      sApp = "StarMath 5.0 (.smf)"
                      DokName2 = "ls_test.smf"

      case "HTMLDOKUMENT" :
                      DokName1 = "ls_test.htm"
                      DokName2 = ""

      case "MASTERDOC" :
                      DokName1 = "ls_test.sxg"
                      ListRead ( sMastList (), ConvertPath ( gTesttoolPath + "framework\first\input\mast_doc_50.txt" ), "utf8" )
                      for i=1 to ListCount ( sMastList () )
                         if iSprache = Val ( Left ( sMastList (i), 2 ) ) then
                            sApp = Right ( sMastList (i), Len ( sMastList (i) ) - 3 )
                            i = 100
                         else
                            sApp = ""
                         end if
                      next i
                      if sApp = "" then
                         warnlog "Please insert for the tested language " + iSprache + " the filtername for 5.0-masterdoc!"
                         DokName2 = ""
                      else
                         DokName2 = "ls_test.sgl"
                      end if
   end select

 printlog "- create a new document"
   call hNewDocument

 printlog "- clipboard"
   call CutCopyPaste

 printlog "- saving => default-fileformat"
   call hSpeichernUnterKill ( gOfficePath + "user\work\" + DokName1 )
   Sleep (3)

   if DokName2 <> "" then
     printlog "- saving => 5.2-fileformat"
      call hSpeichernUnterMitFilterKill ( gOfficePath + "user\work\" + DokName2, sApp )

     printlog "- close"
      FileClose
      Kontext "Active"
      if Active.Exists then
         Active.Yes
      else
         warnlog "No warning for 'loosing data' in old filters is comming up -> bug!"
      end if
   else
      FileClose
      Kontext "Active"
      if Active.Exists then
         warnlog "After saving a messagebox came up : " + messageboxActive.GetText
         try
            Active.Yes
         catch
            Active.No
         endcatch
      end if
   end if

 printlog "- loading => default-fileformat"
   call hDateiOeffnen ( gOfficePath + "user\work\" + DokName1 )

 printlog "  - change the doc"
   call ChangeDoc

 printlog "  - save"
   FileSave
   Sleep (2)

 printlog "  - close"
   call hCloseDocument

   if DokName2 <> "" then
 printlog "- loading => 5.2-fileformat"
      call hDateiOeffnen ( gOfficePath + "user\work\" + DokName2 )

 printlog "  - change the doc"
      call ChangeDoc

 printlog "  - save"
      FileSave
      Sleep (2)
      Kontext "Active"
      if Active.Exists then
         Active.No
      else
         warnlog "No warning to change the to 6.0-filter -> bug!"
      end if

 printlog "  - close"
      FileClose
      Kontext "Active"
      if Active.Exists then
         Active.Yes
      else
         warnlog "No warning for 'loosing data' in old filters is comming up -> bug!"
      end if
   end if

endcase

'-------------------------------------------------------------------------

sub CutCopyPaste
   select case gApplication
      case "WRITER", "HTMLDOKUMENT", "MASTERDOC"
                      Kontext "DocumentWriter"
                      DocumentWriter.TypeKeys "This is a test.<Return>"
                      printlog "   cut"
                      DocumentWriter.TypeKeys "<Mod1 a>"
                      DocumentWriter.TypeKeys "<Mod1 x>"
                      Sleep 1
                      printlog "   paste"
                      DocumentWriter.TypeKeys "<Mod1 v>"
                      Sleep 1
                      printlog "   copy"
                      DocumentWriter.TypeKeys "<Mod1 a>"
                      DocumentWriter.TypeKeys "<Mod1 c>"
                      Sleep 1
                      printlog "   paste"
                      DocumentWriter.TypeKeys "<Mod1 v>"
                      Sleep 1

      case "CALC"   : Kontext "DocumentCalc"
                      DocumentCalc.TypeKeys "This is a test.<Return>"
                      DocumentCalc.TypeKeys "<Up>"
                      printlog "   cut"
                      DocumentCalc.TypeKeys "<Mod1 x>"
                      Sleep 1
                      printlog "   paste"
                      DocumentCalc.TypeKeys "<Down>"
                      DocumentCalc.TypeKeys "<Mod1 v>"
                      Sleep 1
                      printlog "   copy"
                      DocumentCalc.TypeKeys "<Mod1 c>"
                      Sleep 1
                      printlog "   paste"
                      DocumentCalc.TypeKeys "<Down>"
                      DocumentCalc.TypeKeys "<Mod1 v>"
                      Sleep 1

      case "DRAW"   : Kontext "DocumentDraw"
                      hRechteckErstellen ( 30, 30, 60, 60 )
                      gMouseClick ( 1, 1 )
                      printlog "   cut"
                      DocumentDraw.TypeKeys "<Mod1 a>"
                      DocumentDraw.TypeKeys "<Mod1 x>"
                      Sleep 1
                      printlog "   paste"
                      DocumentDraw.TypeKeys "<Mod1 v>"
                      Sleep 1
                      printlog "   copy"
                      gMouseClick ( 1, 1 )
                      DocumentDraw.TypeKeys "<Mod1 a>"
                      DocumentDraw.TypeKeys "<Mod1 c>"
                      Sleep 1
                      printlog "   paste"
                      gMouseClick ( 1, 1 )
                      DocumentDraw.TypeKeys "<Mod1 v>"

      case "IMPRESS": Kontext "DocumentImpress"
                      hRechteckErstellen ( 30, 30, 60, 60 )
                      gMouseClick ( 1, 1 )
                      printlog "   cut"
                      DocumentImpress.TypeKeys "<Mod1 a>"
                      DocumentImpress.TypeKeys "<Mod1 x>"
                      Sleep 1
                      printlog "   paste"
                      DocumentImpress.TypeKeys "<Mod1 v>"
                      Sleep 1
                      printlog "   copy"
                      gMouseClick ( 1, 1 )
                      DocumentImpress.TypeKeys "<Mod1 a>"
                      DocumentImpress.TypeKeys "<Mod1 c>"
                      Sleep 1
                      printlog "   paste"
                      gMouseClick ( 1, 1 )
                      DocumentImpress.TypeKeys "<Mod1 v>"

      case "MATH"   : SchreibenInMathdok "a over b"
                      Sleep (1)
                      printlog "   cut"
                      EditSelectAllMath
                      Sleep (1)
                      EditCut
                      Sleep (1)
                      printlog "   paste"
                      EditPaste
                      Sleep (1)
                      printlog "   copy"
                      EditSelectAllMath
                      Sleep (1)
                      EditCopy
                      Sleep (1)
                      printlog "   paste"
                      EditPaste
                      Sleep (1)
   end select
end sub

'-------------------------------------------------------------------------

sub ChangeDoc

   select case gApplication
      case "WRITER", "HTMLDOKUMENT", "MASTERDOC"
                      Kontext "DocumentWriter"
                      DocumentWriter.TypeKeys "<Return>This doc is changed!"
                      Sleep 1

      case "CALC"   : Kontext "DocumentCalc"
                      DocumentCalc.TypeKeys "<Down>This doc is changed!<Return>"
                      Sleep 1

      case "DRAW"   : Kontext "DocumentDraw"
                      hRechteckErstellen ( 20, 20, 25, 25 )
                      gMouseClick ( 1, 1 )
                      Sleep 1

      case "IMPRESS": Kontext "DocumentImpress"
                      hRechteckErstellen ( 20, 20, 25, 25 )
                      gMouseClick ( 1, 1 )
                      Sleep 1

      case "MATH"   : SchreibenInMathdok "b over c"

   end select
end sub

'-------------------------------------------------------------------------
