'*************************************************************************
'*
'*  $RCSfile: t_tools1.inc,v $
'*
'*  $Revision: 1.2 $
'*
'*  last change: $Author: hde $ $Date: 2003/04/03 11:51:39 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**************************************************************************************
'*
'* owner : joerg.sievers@sun.com
'*
'* short description : Tools
'*
'***************************************************************************************
'*
' #1 GetClipboardText 'Returns the correct clipboard text (also if there is a 'RETURN' at it's end.
' #1 hDoubleClickInList
' #1 Mache8Punkt3 'Reduces files and pathes to 8.3 conventions.
' #1 wielange
' #1 sleep
' #1 WaitInSek
' #1 WaitInMilliSek
' #1 DialogTest 'Creates snapshots
' #1 DialogTest2 'Creates snapshots
' #1 hFindeImDokument 'Searches for a string with the 'Search&Replace'-dlg in a document.
' #1 hFindeMehrImDokument 'Same as 'hFindeImDokument' but needs an integer how often the search-phrase must be found until the boolean gives TRUE back.
' #1 ErgebnisSchreiben
' #1 TextInDatei
' #1 hGetUIFiltername 'Extracts the UI filtername from configuration.
' #1 hGetFilternameExtension 'Extracts the filtername extension from configuration.
' #1 TrimTab 'trimming strings
' #1 lTrimTab 'trimming strings
' #1 rTrimTab 'trimming strings
' #1 GetCountInString 'To extract the count of two characters or text-phrases in a string.
' #1 TrimmString 'Cuts all ASCII characters which are defined by a parameter (e.g. 32 space will be deleted)
' #1 ActiveDeactivateAsianSupport 'Acivates/Deactivates the Asian support in StarOffice
' #1 hGetStringInSeperatorString 'Seperates Strings with a seperator of your choice.
' #1 hGetFilterDataValue 'sub routine to get the values of <i>TypeDetection.xcu</i>
'*
'\*************************************************************************************

function GetClipboardText as string
'/// Returns the correct clipboard text (also if there is a 'RETURN' at it's end.
   Dim i% : Dim CBText$
   Dim Zwischen$

   wait 500
   GetClipboardText = ""
   CBText$ = GetClipboard

   if CBText$ = "" then
      GetClipboardText = ""
      exit function
   end if

   if asc ( Right( CBText$, 1 )) = 10 then
      Zwischen$ = Mid( CBText$, 1, len(CBText$)-1 )
      if Zwischen$ <> "" then
         if asc ( Right( Zwischen$, 1 )) = 13 then
            GetClipboardText = Mid( Zwischen$, 1, len(Zwischen$)-1 )
         else
            GetClipboardText = Zwischen$
         end if
      else
         GetClipboardText = Zwischen$
      end if
   else
      if asc ( Right( CBText$, 1 )) = 13 then
         Zwischen$ = Mid( CBText$, 1, len(CBText$)-1 )
         if asc ( Right( Zwischen$, 1 )) = 10 then
            GetClipboardText = Mid( Zwischen$, 1, len(Zwischen$)-1 )
         else
            GetClipboardText = Zwischen$
         end if
      else
         GetClipboardText = CBText$
      end if
   end if
end function

'-------------------------------------------------------------------------

function hDoubleClickInList ( window, Selektion as String, optional bFocus as boolean ) as Boolean
'/// hDoubleClickInList
'///+ Makes a double click onto an entry in a list (tested only in <i>style lists</i>)

  Dim i as Integer : Dim AlterWert as String : Dim NeuerWert as String

   NeuerWert = "!=!  !=!"                ' den neuen Eintrag auf einen Dummywert setzen
   window.TypeKeys "<Home>"
   for i=1 to 100 step 2
      window.MouseDown 5, i +1
      window.MouseUp 5, i +1
      AlterWert = window.GetText
      window.TypeKeys "<Down>"
      NeuerWert = Window.GetText
      window.TypeKeys "<Up>"
      if AlterWert = Selektion then
         window.MouseDown 5, i +1
         window.MouseUp 5, i +1
         if Window.GetText = Selektion then     ' Abfangen ob durch das <down> gescrollt wurde
            window.MouseDoubleClick 5, i +1
            if (isMissing (bFocus) = FALSE) then
               window.MouseDown 5, i +1
               window.MouseUp 5, i +1
            endif
            i = 202
         else
            i=0                                 ' es wird wieder oben in der Liste angefangen
         end if
      else
         if AlterWert = NeuerWert then
            Warnlog "'" + Selektion + "' wurde in der Liste nicht gefunden! Vielleicht wurde in der Liste falsch gescrollt!"
            i = 202
         else
           if i > 98 then i=40                  ' die Liste ist noch nicht am Ende aber es wurde gescrollt
         end if
      end if
   next i
   if i < 200 OR i > 100 then
      hDoubleClickInList = FALSE
   else
      hDoubleClickInList = TRUE
   end if
end function

'-------------------------------------------------------------------------

sub hMouseClick ( window, xPos, yPos )
' Author: Thorsten Ziehm (26.09.2000)
'/// hMouseClick
'///+ Do a mouse click on a named window.
'/// <i>Input</i>:
'///+ window : The object on which the mouse click should be make (document, listbox, window)
'///+ xPos : x-position (relativ to the size of the window (1:100)
'///+ yPos : y-position (relativ to the size of the window (1:100)
   window.MouseDown ( xPos, yPos )
   window.MouseUp ( xPos, yPos )
end sub

'-------------------------------------------------------------------------

function Mache8Punkt3 ( ZwischenWert as String ) as String
' Author: Thorsten Ziehm (20.08.1998)
'/// Mache8Punkt3
'///+ Cuts a string to 8.3 convention (DOS)
'///+ Pathes and file names will be reduced to 8 chars, the extension to 3.
'///+ Only files with 4 chars as extensions will be reduced to 3 (e.g. .HTML to .HTM)
   Dim i as Integer, j as Integer, Zaehler as Integer, Laenge as Integer, Max as Integer
   Dim Zwischen2 as String, Stabe as String
   Dim Punkt as Boolean

   Zwischen2 = ""
   if Len (ZwischenWert) > 4 then
      if Mid ( ZwischenWert, Len (ZwischenWert)-4 ,1 ) = "." then ZwischenWert = Left ( ZwischenWert, Len (ZwischenWert) - 1 )
   end if
   Laenge = Len ( ZwischenWert )

'Only filenames without pathes will be reduced in this section:

   for i=1 to Laenge
      if Mid ( ZwischenWert, i, 1 ) = "\" then i=1000
   next i

   if i <> 1001 then
      for j=1 to 9
         if Mid ( ZwischenWert, j, 1 ) = "." then Punkt = TRUE
      next j
      if Punkt = TRUE then
         Zwischen2 = ZwischenWert
      else
         Zwischen2 = Left ( ZwischenWert, 8 ) + Right (ZwischenWert, 4 )
      end if
      Mache8Punkt3 = Zwischen2
      exit function
   end if

'Only filenames, INCLUDING pathes will be reduced in this section:

   Zaehler = 0
   Max = 0
   for i=1 to Laenge
      Zaehler = Zaehler + 1
      Stabe = Mid ( ZwischenWert, i, 1 )
      if Stabe = "\" then
         Zaehler = 0
         Max = 8
      end if
      if Stabe = "." then
         Zaehler = 0
         Max = 3
      end if
      Zwischen2 = Zwischen2 + Stabe
      if Zaehler = Max then
         for j=1 to ( Laenge - i )
            i = i + 1
            Stabe = Mid ( ZwischenWert, i, 1 )
            if Stabe = "\" OR Stabe = "." then
               Zwischen2 = Zwischen2 + Stabe
               j=1000
            end if
         next j
         Zaehler = 0
      end if
   next i
  Mache8Punkt3 = Zwischen2
end function

'-------------------------------------------------------------------------

function wielange (StrtTime) as String
' Author: Michael Friedrichs
'/// wielange
'///+ Returns the time between a start- and an end timeframe.
   Dim Zeitspanne
   Dim Zeitspannesek
   Dim Zeitspannemin
   Dim Zeitspanneh

   Zeitspanne = Now() - StrtTime
   Zeitspannesek = Zeitspanne / 1.15741E-05 + 1
   Zeitspanneh = Fix(Zeitspannesek / 3600)
   Zeitspannesek = Zeitspannesek - Zeitspanneh * 3600
   Zeitspannemin = Fix(Zeitspannesek / 60)
   Zeitspannesek = Zeitspannesek - Zeitspannemin * 60
   Zeitspannesek = Fix(Zeitspannesek)
   wielange = "" & Zeitspanneh & "h " & Zeitspannemin & "m " & Zeitspannesek & "s"
end function

'-------------------------------------------------------------------------

sub WaitInSek ( Sekunden )
' Author: Thorsten Ziehm
'/// WaitInSek
'///+ Wait exactly x second(s) (using GetSystemTicks)
  Dim i : Dim t0 : Dim t1
   t0 = GetSystemTicks()
   for i=1 to 10000*Sekunden
      t1 = GetSystemTicks()
      if t1-t0 > 1000*Sekunden then i=11000*Sekunden
   next i
end sub

'-------------------------------------------------------------------------

sub WaitInMilliSek ( Milli )
' Author: Thorsten Ziehm
'/// WaitInMilliSek
'///+ Wait exactly x millisecond(s) (using GetSystemTicks)
  Dim i : Dim t0 : Dim t1
   t0 = GetSystemTicks()
   for i=1 to 1000*Milli
     t1 = GetSystemTicks
     if t1-t0 > Milli then i=1001*Milli
   next i
end sub

'-------------------------------------------------------------------------

sub sleep ( i% )
'/// sleep
'///+ simple sleep routine which uses seconds.
'   WaitInSek ( i% )
   wait i%*1000
end sub

'-------------------------------------------------------------------------

sub DialogTest( Window )
'/// DialogTest
'///+ Make <i>SnapShots</i>
   Dim Ergebnis as Integer
   Dim Ausgabe as String
   Dim UndRaus as Boolean

   if gDasNicht=0 then
      Ausgabe = ""
      UndRaus = FALSE
      while UndRaus = FALSE
         Ausgabe = translate
         if Ausgabe <> "" OR Ausgabe <> "1" then
            if Left ( Ausgabe, 1 ) = "0" then
               Ausgabe = Right ( Ausgabe, Len( Ausgabe )- 2 )
               AnhaengenAnDatei ( gOfficePath + "trans_output.txt", Ausgabe )
            end if
         end if
         if Ausgabe = "1" then UndRaus = TRUE
      wend
   else
      try
         if Not window.Exists(2) then
            Warnlog "   - Window nicht existent:" + window.Name + " " + window.ID
            exit sub
         end if
   '      AnhaengenAnDatei ( "c:\wieviel.txt", window.Name + " : " + window.ID )
      catch
         ExceptLog
      endcatch
   end if

   if gbSnapShot = TRUE then
      Dim Dummy as String, sName as String, sPicName as String

      Dummy = Window
      sName = Dummy + ".bmp"

      if gPlatgroup = "unx" then
         sCapturePath = "/q_testtool/temp/screenshots/"
'         sCapturePath = ConvertPath ( gOfficePath + "user\work\screenshots\" )
         if hDirectoryExists ( sCapturePath ) <> TRUE then
            sCapturePath = "/net/mahler/export/home/q_testtool/temp/screenshots/"
         end if
      else
         sCapturePath = ConvertPath ( gOfficePath + "user\work\screenshots\" )
         printlog "Path of the Screenshots will be " & sCapturepath
      end if

      select case gApplication
         case "WRITER"  : sPicName = sCapturePath + "writer" + gPathsigne + sName
         case "DRAW"    : sPicName = sCapturePath + "draw" + gPathsigne + sName
         case "IMPRESS" : sPicName = sCapturePath + "impress" + gPathsigne + sName
         case "CALC"    : sPicName = sCapturePath + "calc" + gPathsigne + sName
         case "CHART"   : sPicName = sCapturePath + "chart" + gPathsigne + sName
         case "MATH"    : sPicName = sCapturePath + "math" + gPathsigne + sName
         case else      : sPicName = sCapturePath + "desktop" + gPathsigne + sName
      end select
      window.SnapShot( sPicName )
   end if
end sub

'-----------------------------------------------------------

sub DialogTest2( Window, i% )
'/// DialogTest2
'///+ Make <i>SnapShots</i>
   Dim Ergebnis as Integer
   Dim Ausgabe as String
   Dim UndRaus as Boolean

   if gDasNicht=0 then
      Ausgabe = ""
      UndRaus = FALSE
      while UndRaus = FALSE
         Ausgabe = translate
         if Ausgabe <> "" OR Ausgabe <> "1" then
            if Left ( Ausgabe, 1 ) = "0" then
               Ausgabe = Right ( Ausgabe, Len( Ausgabe )- 2 )
               AnhaengenAnDatei ( gOfficePath + "trans_output.txt", Ausgabe )
            end if
         end if
         if Ausgabe = "1" then UndRaus = TRUE
      wend
   else
      try
         if Not window.Exists(2) then
            Warnlog "   - Window nicht existent:" + window.Name + " " + window.ID
            exit sub
         end if
'         AnhaengenAnDatei ( "c:\wieviel.txt", window.Name + " " + i% + " : " + window.ID )
      catch
         ExceptLog
      endcatch
   end if

   if gbSnapShot = TRUE then
      Dim Dummy as String, sName as String, sPicName as String

      Dummy = Window
      sName = Dummy + "_" + i% + ".bmp"

      if gPlatgroup = "unx" then
         sCapturePath = "/q_testtool/temp/screenshots/"
'         sCapturePath = ConvertPath ( gOfficePath + "user\work\screenshots\" )
         if hDirectoryExists ( sCapturePath ) <> TRUE then
            sCapturePath = "/net/mahler/export/home/q_testtool/temp/screenshots/"
         end if
      else
         sCapturePath = ConvertPath ( gOfficePath + "user\work\screenshots\" )
         printlog "Path of the Screenshots will be " & sCapturepath
      end if

      select case gApplication
         case "WRITER"  : sPicName = sCapturePath + "writer" + gPathsigne + sName
         case "DRAW"    : sPicName = sCapturePath + "draw" + gPathsigne + sName
         case "IMPRESS" : sPicName = sCapturePath + "impress" + gPathsigne + sName
         case "CALC"    : sPicName = sCapturePath + "calc" + gPathsigne + sName
         case "CHART"   : sPicName = sCapturePath + "chart" + gPathsigne + sName
         case "MATH"    : sPicName = sCapturePath + "math" + gPathsigne + sName
         case else      : sPicName = sCapturePath + "desktop" + gPathsigne + sName
      end select
      window.SnapShot( sPicName )
   end if
end sub

'-------------------------------------------------------------------------

function hFindeImDokument ( Passage$ , Optional A, optional bRegEx ) as boolean
' Author: Joerg Sievers (13.11.2001)
'/// hFindeImDokument
'/// Searches via 'Search&Replace'-Dlg in StarOffice Writer, -Clac,
'///+ -HTML, -GlobalDoc for the string <b>EXACT MATCH</b>.
'///+ Only ONE TIME and THE FIRST search phrase will be found!
'/// <i>Optional Parameter</i> <b>a</b> : If you do not want a warnlog message
'/// <i>Optional Parameter</i> <b>bRegEx</b> : if you look fort an regular expression
 Dim WhatIsIn as string
   gApplication = UCase ( gApplication )

   hFindeImDokument = FALSE

   select case gApplication

      case "CALC"        : Kontext "DocumentCalc"
                           DocumentCalc.TypeKeys "<MOD1 HOME>"

      case "WRITER"      : Kontext "DocumentWriter"
                           DocumentWriter.TypeKeys "<MOD1 HOME>"

      case "NACHRICHT"   : Kontext "DokumentNachrichten"
                           DokumentNachrichten.TypeKeys "<MOD1 HOME>"

      case "HTMLDOKUMENT": Kontext "DocumentWriterWeb"
                           DocumentWriterWeb.TypeKeys "<MOD1 HOME>"

      case "GLOBALDOC"   : Kontext "DocumentMasterDoc"
                           DocumentMasterDoc.TypeKeys "<MOD1 HOME>"

   end select

  SetClipboard ""
  EditSearchAndReplace
  Kontext "SuchenUndErsetzenWriter"
  if not ExakteSuche.IsChecked then ExakteSuche.Check
  if Aehnlichkeitssuche.IsChecked = TRUE then
   Aehnlichkeitssuche.UnCheck
   warnlog "'Similar search' checkbox was enabled! It shouldn't be the default!"
  end if
  if IsMissing(bRegEx) <> TRUE then RegulaererAusdruck.Check
  SuchenNach.Settext Passage$
  Suchen.Click
  Kontext
  'workaround for a time bug
  if gPlatgroup = "unx" then
   sleep(5)
  end if
  if NOT Active.Exists(2) then
    SuchenUndErsetzenWriter.Cancel
     EditCopy
     WhatIsIn = GetClipboardText
     if WhatIsIn <> Passage$ then
      if IsMissing(A) then
       warnlog "The search-request for '" & Passage$ & "' has been fault! (Found: '"& WhatIsIn & "')"
      end if
      else
       hFindeImDokument = TRUE
     end if
  else
   try
     Active.OK
      Kontext
       if Active.Exists then Active.OK
       warnlog "The search-request for '" & Passage$ & "' has been fault! (Found: '"& WhatIsIn & "')"
        Kontext "SuchenUndErsetzenWriter"
         if ExakteSuche.IsChecked then ExakteSuche.UnCheck
         if Aehnlichkeitssuche.IsChecked = TRUE then
          Aehnlichkeitssuche.UnCheck
          warnlog "'Similar search' checkbox was enabled! It shouldn't be the default!"
         end if
         if IsMissing(bRegEx) <> TRUE then RegulaererAusdruck.UnCheck
         SuchenUndErsetzenWriter.Cancel
    catch
      Active.Yes
       Kontext
        if IsMissing(A) <> TRUE then
           if Active.Exists then printlog "> "+Active.GetText
        endif
        if Active.Exists then Active.OK
        if IsMissing(A) then
           warnlog "The search-request for '" & Passage$ & "' has been fault! (Found: '"& WhatIsIn & "')"
        endif
        Kontext "SuchenUndErsetzenWriter"
         if ExakteSuche.IsChecked then ExakteSuche.UnCheck
         if Aehnlichkeitssuche.IsChecked = TRUE then
          Aehnlichkeitssuche.UnCheck
          warnlog "'Similar search' checkbox was enabled! It shouldn't be the default!"
         end if
         if IsMissing(bRegEx) <> TRUE then RegulaererAusdruck.UnCheck
         SuchenUndErsetzenWriter.Cancel
    endcatch
  end if
end function

'-------------------------------------------------------------------------

function hFindeMehrImDokument ( Passage as string , WieOft as integer ) as boolean
' Author: Joerg Sievers (26.07.2000)
'/// hFindeMehrImDokument
'/// Searches per 'Search&Replace'-Dlg in StarOffice Writer, -Clac,
'///+-HTML, -GlobalDoc for the string <b>EXACT MATCH</b>.
'/// You have to give the function the number how often the phrase
'///+should be found in the document as an additional parameter (as integer).
'/// Only when exact the number of the phrase will be found correctly
'///+the function gives back TRUE.
'/// <i>see also</i> : hFindeImDokument (TOOLS.INC)
   Dim i as integer
   gApplication = UCase ( gApplication )

   hFindeMehrImDokument = FALSE

   select case gApplication

      case "CALC"        : Kontext "DocumentCalc"
                           DocumentCalc.TypeKeys "<MOD1 HOME>"

      case "WRITER"      : Kontext "DocumentWriter"
                           DocumentWriter.TypeKeys "<MOD1 HOME>"

      case "NACHRICHT"   : Kontext "DokumentNachrichten"
                           DokumentNachrichten.TypeKeys "<MOD1 HOME>"

      case "HTMLDOKUMENT": Kontext "DocumentWriter"
                           DocumentWriter.TypeKeys "<MOD1 HOME>"

      case "GLOBALDOC"   : Kontext "DocumentMasterDoc"
                           DocumentMasterDoc.TypeKeys "<MOD1 HOME>"

   end select

   SetClipboard ""
   EditSearchAndReplace

 For i = 1 to WieOft
  Kontext "SuchenUndErsetzenWriter"
   if NOT ExakteSuche.IsChecked then ExakteSuche.Check
   SuchenNach.Settext Passage
   Suchen.Click
  Kontext
   if NOT Active.Exists(2) then
     SuchenUndErsetzenWriter.Cancel
      EditCopy
      if GetClipboardText <> Passage then
        warnlog "The search-request for '" & Passage & "' has been fault!"
        i = WieOft
       else
        if i = WieOft then
          hFindeImDokument = TRUE
          printlog "Searchphrase found " & i & " time(s)."
        end if
      end if
    else
     try
       Active.OK
        Kontext
         if Active.Exists then Active.OK
         warnlog "The search-request for '" & Passage & "' has been fault!"
          i = WieOft
          Kontext "SuchenUndErsetzenWriter"
           if ExakteSuche.IsChecked then ExakteSuche.UnCheck
           SuchenUndErsetzenWriter.Cancel
      catch
        Active.Yes
         Kontext
          if Active.Exists then Active.OK
          warnlog "The search-request for '" & Passage & "' has been fault!"
          i = WieOft
          Kontext "SuchenUndErsetzenWriter"
           if ExakteSuche.IsChecked then ExakteSuche.UnCheck
           SuchenUndErsetzenWriter.Cancel
      endcatch
   end if
  Next i
  Kontext "SuchenUndErsetzenWriter"
   if SuchenUndErsetzenWriter.Exists(2) then
     SuchenUndErsetzenWriter.Cancel
   end if
end function

'-------------------------------------------------------------------------

sub ErgebnisSchreiben ( Window, Name$ )
'/// ErgebnisSchreiben
'///+ Used in context with making screenshots.
  Dim FileNum% : Dim i%
  Dim Datei$
  Dim Text$ : Dim Text2$

  Datei$ = sCapturePath + "Ergebis.txt"
  Text2$ = Window.Name
  Text$ = Text2$ +  "    =>   " + Name$

  FileNum% = FreeFile
  Open Datei$ for Append  as #FileNum%
  Print #FileNum%, Text$
  Close #FileNum%
end sub

'-------------------------------------------------------------------------

sub TextInDatei ( TextText$, Datei$ )
'/// TextInDatei
  Dim FileNum%

  FileNum% = FreeFile
  Open Datei$ for Append  as #FileNum%
  Print #FileNum%, TextText$
  Close #FileNum%
end sub

'-------------------------------------------------------------------------

sub hGetUIFiltername( vFiltername as string ) as string
' Author: Joerg Sievers (September 2002)
'/// hGetUIFiltername
'/// Gets the language dependent filter name for a named filter.
'///+ The <i>TypeDetection.xml</i> in <i>share/registry/res/<i>gISOLang</i>/org/openoffice/Office/</i>
'///+ will be parsed by <i>SAX-Routines</i> for the language dependent filter name.
  Dim CountOfElements as integer
  Dim CountOfElementsB as integer
  Dim i as integer
  Dim a as integer
  Dim xReadThisFile as string
  Dim AttributeNameValue as string
  Dim Back2Here as string

  hGetUIFiltername = ""
  if gNetzInst = TRUE then
  ' If an 'en-US' office has been installed the 'default' registry file has to
  ' be used because the language dependent TypeDetection.xcu is a diff'ed
  ' version to the default - and the file is empty in the ../res-tree in that language.
    if lcase(gISOLang) = "en-us" then
      xReadThisFile = gNetzOfficePath & ConvertPath("share\registry\data\org\openoffice\Office\TypeDetection.xcu")
     else
      xReadThisFile = gNetzOfficePath & ConvertPath("share\registry\res\" & gISOLang & "\org\openoffice\Office\TypeDetection.xcu")
    end if
   else
  ' If an 'en-US' office has been installed the 'default' registry file has to
  ' be used because the language dependent TypeDetection.xcu is a diff'ed
  ' version to the default - and the file is empty in the ../res-tree in that language.
    if lcase(gISOLang) = "en-us" then
      xReadThisFile = gOfficePath & ConvertPath("share\registry\data\org\openoffice\Office\TypeDetection.xcu")
     else
      xReadThisFile = gOfficePath & ConvertPath("share\registry\res\" & gISOLang & "\org\openoffice\Office\TypeDetection.xcu")
    end if
  end if
  if Dir (xReadThisFile) = "" then
    warnlog "t_tools1.inc::hGetUIFiltername: " & xReadThisFile & " not found => can't get the correct 'Text' UI filter name! Aborting!"
    Exit sub
   else
    SAXReadFile(xReadThisFile)
    SAXSeekElement("/")
    SAXSeekElement(1)
    CountOfElements = SAXGetChildCount
    for i = 1 to CountOfElements
     SAXSeekElement(i)
      if SAXGetAttributeValue("oor:name") = "Filters" then
       Back2Here = SAXGetElementPath
       CountOfElementsB = SAXGetChildCount
       for a = 1 to CountOfElementsB
        SAXSeekElement("node" , a)
        AttributeNameValue = SAXGetAttributeValue("oor:name")
          if AttributeNameValue = vFiltername then
            a = CountOfElementsB
            SAXSeekElement(1)
            SAXSeekElement(1)
            SAXSeekElement(1)
            hGetUIFiltername = SAXGetChars
            if hGetUIFiltername <> "" then
              printlog "t_tools1.inc::hGetUIFiltername() : The UIName for the " & vFiltername & " filter is: >" & hGetUIFiltername & "<."
              exit sub
             else
              warnlog "t_tools1.inc::hGetUIFiltername() : The UIName for the " & vFiltername & " filter is missing in '" & xReadThisFile & "'!"
              exit sub
            end if
           else
            SAXSeekElement(Back2Here)
          end if
       next a
       i = CountOfElements
      end if
     SAXSeekElement(0)
    next i
    SAXRelease()
  end if
end sub

'-------------------------------------------------------------------------

sub hGetFilternameExtension ( vFilterName as string) as string
' Author: Joerg Sievers (September 2002)
'/// hGetFilternameExtension
'/// Gets the extension for a filter name.
'///+ The <i>TypeDetection.xml</i> in <i>share/registry/data/org/openoffice/Office/</i>
'///+ will be parsed by <i>SAX-Routines</i> for the filter name.
  Dim xReadThisFile as string
  Dim xFilterA as string
  Dim xFilterB as string

  hGetFilternameExtension = ""
  if gNetzInst = TRUE then
    xReadThisFile = gNetzOfficePath & ConvertPath("share\registry\data\org\openoffice\Office\TypeDetection.xcu")
   else
    xReadThisFile = gOfficePath & ConvertPath("share\registry\data\org\openoffice\Office\TypeDetection.xcu")
  end if
  if Dir (xReadThisFile) = "" then
    warnlog "t_tools1.inc::hGetFilternameExtension: " & xReadThisFile & " not found => can't get the correct 'Text' UI filter name! Aborting!"
    Exit sub
   else
    printlog "...please wait."
    xFilterA =  hGetFilterDataValue( xReadThisFile , "Filters" , vFilterName , 2 )
    printlog "...please wait."
    xFilterB =  hGetFilterDataValue( xReadThisFile , "Types" , xFilterA , 5 )
    if xFilterB <> "" then
      hGetFilternameExtension = xFilterB
      printlog "t_tools1.inc::hGetFilternameExtension(" & vFilterName & "): Extension is >" & hGetFilternameExtension & "<."
     else
      warnlog "t_tools1.inc::hGetFilternameExtension(" & vFilterName & "): Extension can not be empty!"
    end if
  end if
end sub

'-------------------------------------------------------------------------

function TrimTab ( sTrimmer as String ) as String
'/// TrimTab
'/// <u>Input</u>: the original text
'/// Returns the string without &lt;tab&gt;s at the beginning and the end of a string.
   Dim sInterim as String

   sInterim = sTrimmer
   sInterim = lTrimTab ( sInterim )
   TrimTab = rTrimTab ( sInterim )

end function

'-------------------------------------------------------------------------

function lTrimTab ( slTrimmer as String ) as String
'/// lTrimTab
'/// <u>Input</u>: the original text
'/// Returns the string without &lt;tab&gt;s at the beginning.
'/// Cuts &lt;Tab's&gt; at the beginning of a string ( left )
   Dim i, iLen as Integer
   Dim sInterim as String

   iLen = len ( slTrimmer )
   sInterim = slTrimmer

   for i=1 to iLen
      if Asc ( left ( sInterim, 1 ) ) = 9 then
         sInterim = Right ( sInterim, len ( sInterim ) - 1 )
      else
         i=iLen+1
      end if
   next i
   lTrimTab = sInterim
end function

'-------------------------------------------------------------------------

function rTrimTab ( srTrimmer as String ) as String
'/// rTrimTab
'/// Input: the original text
'/// Returns the string without &lt;tab&gt;s at the end.
'/// Cuts &lt;Tab's&gt; at the beginning of a string ( right )

   Dim i, iLen as Integer
   Dim sInterim as String

   iLen = len ( srTrimmer )
   sInterim = srTrimmer

   for i=1 to iLen
      if Asc ( right ( sInterim, 1 ) ) = 9 then
         sInterim = left ( sInterim, len ( sInterim ) - 1 )
      else
         i=iLen+1
      end if
   next i
   rTrimTab = sInterim
end function

'-------------------------------------------------------------------------

function TrimString (Content as String, delim as integer) as String
' Author: Frank Heitbrock (26.07.2002)
'/// TrimString
'/// <u>Input</u>: The  String, the delimiter which should be cut from the string.
'/// Returns the String without the delimiter.
'/// <u>Example</u>:
'///+ Content = &quot;&nbsp;H&nbsp;a&nbsp;l&nbsp;l&nbsp;o&nbsp;&quot;, delim = 32 (ascii for space character)
'///+ Return = &quot;Hallo&quot;
   dim strlen as integer, i as integer, k as integer
   dim CharBuff(1 to 100) as String
   dim ResultStr as String
   ' at first cut the empty strings left and right of the String
   Content = lTrim(Content)
   Content = rTrim(Content)
   ' now we search for all appropriate ascii characters in the middle of the String and delete them
   strlen = len(Content)
   k = 1
   for i = 1 to strlen
      if mid(Content, i, 1) <> chr(delim) then
         CharBuff(k) = mid(Content, i, 1)
         k = k +1
      end if
   next i
   for i = 1 to k
      ResultStr = ResultStr + CharBuff(i)
   next i
   TrimString = ResultStr

end function

'-------------------------------------------------------------------------

function GetCountInString (InputString as string, SearchString as string) as integer
' Author: Joerg Sievers
'/// GetCountInString
'///+ To extract the count of two characters or text-phrases in a string.
'/// <u>Example</u>:
'///+ InputString = &quot;text:style-name=&quot; &amp; CHR$(34) &amp; &quot;P4&quot; &amp; CHR$(34) &amp; &quot;&gt;&lt;text:span text:style-name=&quot; &amp; CHR$(34) &amp; &quot;T4&quot; &amp; CHR$(34)
'///+ GetCountInString (InputString , "style-name")
'///+ Return: 2
 Dim i as integer
 Dim a as integer
 Dim TempPos as integer

 TempPos = InStr(InputString , SearchString)
  If TempPos = 0 then
     GetCountInString = 0
     exit function
   else
    a = 1
     For i = 1 to Len(InputString)
       TempPos = InStr(TempPos+1, InputString , SearchString)
       If TempPos <> 0 then
          a = a+1
         else
          exit For
       End If
     Next i
    GetCountInString = a
  End If
end function

'-------------------------------------------------------------------------

function ActiveDeactivateAsianSupport ( WhatState as Boolean ) as Boolean
' Author: Thorsten Ziehm
'/// ActiveDeactivateAsianSupport
'/// <u>Input</u>: TRUE or FALSE
'///+ TRUE: The Asian support will be enabled.
'///+ FALSE:  The Asian support will be disabled.
'/// <u>Return:</u>
'///+ TRUE/FALSE for the last state of the checkbox in the office UI.
   ToolsOptions
   hToolsOptions ( "LanguageSettings", "Languages" )

   ActiveDeactivateAsianSupport = Aktivieren.IsChecked         ' the function gets the old state of the checkbox

   if WhatState = TRUE then
      Aktivieren.Check
   else
      Aktivieren.UnCheck
   end if
   gAsianSup = WhatState    ' Set the global variable

   Kontext "ExtrasOptionenDlg"
   ExtrasOptionenDlg.OK
   Sleep (3)

end function

'-------------------------------------------------------------------------

function hGetStringInSeperatorString ( SeperatList as string, SeperatPos as integer, Seperator as string) as string
' Author: Joerg Sievers (September 2002)
'/// hGetStringInSeperatorString
'/// <u>Input</u>:
'///+ A string with delimiter (e.g. , or ;).
'///+ The string you want to get in the seperated string (e.g. &quot;hallo,world,here,i,am&quot; and you want to get the second, just give a 2 as parameter).
'///+ The sign which is used as delimiter (e.g. a , for a comma seperated string)
'/// <u>Return</u>:
'///+ The strings between the delimiter - without the delmiters.
 Dim i as integer
 Dim a as integer
 Dim MaxCharToUse as integer
 Dim TempPos as integer
 Dim TempStrg as string

 'return string is empty
 hGetStringInSeperatorString = ""

 'loop until the count of SeperatPos reached
 for i = 1 to SeperatPos
  'Detecting the count of characters in the string
  MaxCharToUse = Len(SeperatList)
  'TempPos is the position of the (next) seperator in the string (e.g. , or ;)
  TempPos = InStr(SeperatList , Seperator)
  'IMPORTANT if no seperator is included in the string (anymore)...
  if TempPos = 0 then
    '...it is may be the searched string if the MaxCharToUse <> 0!
    if i = SeperatPos AND MaxCharToUse <> 0 then
      hGetStringInSeperatorString = SeperatList
      exit function
     else
      'otherwise the function failed (less strings).
      warnlog "t_tools1.inc::hGetStringInSeperatorString(): No '" & Seperator & "'-seperated string or not enough seperated entries in the given string ("& SeperatList & ")!"
      exit function
    end if
   else
    'if the TempPos <> 0 get the string - the seperated string (and - the seperator in iself)
    TempStrg = Left(SeperatList, TempPos-1)
    'IMPORTANT if the extracted string is a seperator just go to the next with the string (excluding the last seperator)
    if TempStrg = Seperator then
     SeperatList = Right(SeperatList, MaxCharToUse-Tempos)
     else
      'otherwise
      if i = SeperatPos then
        'if the loop reaches the target count then return the TempStrg
        hGetStringInSeperatorString = TempStrg
        exit function
      end if
      'if no condition was true just extract the string
      '(without seperator in itself and the string in front of the seperator)
      SeperatList = Right(SeperatList, MaxCharToUse-TempPos)
    end if
  end if
 next i
end function

'-------------------------------------------------------------------------

sub hGetFilterDataValue( xReadThisFile as string , xtreename as string , xfilter as string , xsepcounter as integer ) as string
' Author: Joerg Sievers (September 2002)
'/// hGetFilterDataValue
'/// Sub routine to find in <i>Types</i> or in <i>Data</i> node of the
'///+ <i><b>TypeDetection.xcu</i></b> the character child node from the
'///+ <i>&lt;value&gt;</i> node.
'/// <u>See also</u>: hGetFilternameExtension()
SAXReadFile(xReadThisFile)
 Dim x as integer
 Dim y as integer
 Dim z as integer
 Dim CountOfElementsX as integer
 Dim CountOfElementsY as integer
 Dim CountOfElementsZ as integer
 Dim AttributeNameValue as string
 Dim FirstSectionString
 Dim SecondSectionString
 SAXSeekElement("/")
  SAXSeekElement(1)
  CountOfElementsX = SAXGetChildCount
  for z = 1 to CountOfElementsX
   SAXSeekElement(z)
    if SAXGetAttributeValue("oor:name") = xtreename then
     z = CountOfElementsX
     CountOfElementsY = SAXGetChildCount
     for y = 1 to CountOfElementsY
      SAXSeekElement("node" , y)
       AttributeNameValue = SAXGetAttributeValue("oor:name")
       if AttributeNameValue = xfilter then
        y = CountOfElementsY
        CountOfElementsZ = SAXGetChildCount
         for x = 1 to CountOfElementsZ
          SAXSeekElement("prop" , x )
           AttributeNameValue = SAXGetAttributeValue("oor:name")
            if AttributeNameValue = "Data" then
              x = CountOfElementsZ
                if SAXHasElement("value") = TRUE then
                  SAXSeekElement("value")
                   SAXSeekElement(1)
                    FirstSectionString = SAXGetChars
                    SAXRelease()
                    if FirstSectionString <> "" then
                       if xsepcounter <> 0 then
                         'seperating the comma seperated string and return it
                         SecondSectionString = hGetStringInSeperatorString(FirstSectionString , xsepcounter, ",")
                        else
                         'if no seperation is needed
                         SecondSectionString = FirstSectionString
                       end if
                       'here is the result!
                       hGetFilterDataValue = SecondSectionString
                       'printlog "DEBUG: t_tools1.inc::hGetFilterDataValue::SecondSectionString = " & SecondSectionString
                       exit sub
                     else
                      warnlog "t_tools1.inc::hGetFilterDataValue(" & xReadThisFile & " , " & xtreename & " , " & xfilter &"): The extension is empty!"
                    end if
                 else
                  warnlog "t_tools1.inc::hGetFilterDataValue(" & xReadThisFile & " , " & xtreename & " , " & xfilter &"): The 'value' element is missing!"
                end if
            end if
          SAXSeekElement(0)
         next x
       end if
      SAXSeekElement(0)
     next y
    end if
   SAXSeekElement(0)
  next z
end sub

'-------------------------------------------------------------------------

